/[gentoo-x86]/eclass/font.eclass
Gentoo

Diff of /eclass/font.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.2 Revision 1.50
1# Copyright 1999-2004 Gentoo Technologies, Inc. 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/font.eclass,v 1.2 2004/05/31 14:59:26 foser Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/font.eclass,v 1.50 2010/05/15 05:25:32 dirtyepic Exp $
4 4
5# Author: foser <foser@gentoo.org> 5# @ECLASS: font.eclass
6 6# @MAINTAINER:
7# Font Eclass 7# fonts@gentoo.org
8#
9# Eclass to make font installation more uniform 8# @BLURB: Eclass to make font installation uniform
10 9
11ECLASS="font" 10inherit eutils
12INHERITED="$INHERITED $ECLASS"
13 11
14# 12EXPORT_FUNCTIONS pkg_setup src_install pkg_postinst pkg_postrm
15# Variable declarations
16#
17 13
14# @ECLASS-VARIABLE: FONT_SUFFIX
15# @DESCRIPTION:
18FONT_SUFFIX="" # Space delimited list of font suffixes to install 16# Space delimited list of font suffixes to install.
17FONT_SUFFIX=${FONT_SUFFIX:=}
19 18
20FONT_S="${S}" # Dir containing the fonts 19# @ECLASS-VARIABLE: FONT_S
20# @DESCRIPTION:
21# Working directory containing the fonts.
22FONT_S=${FONT_S:=${S}}
21 23
22DOCS="" # Docs to install 24# @ECLASS-VARIABLE: FONT_PN
25# @DESCRIPTION:
26# Font name (ie. last part of FONTDIR).
27FONT_PN=${FONT_PN:=${PN}}
23 28
24IUSE="${IUSE} X" 29# @ECLASS-VARIABLE: FONTDIR
30# @DESCRIPTION:
31# Full path to installation directory.
32FONTDIR=${FONTDIR:-/usr/share/fonts/${FONT_PN}}
25 33
26DEPEND="${DEPEND} \ 34# @ECLASS-VARIABLE: FONT_CONF
27 X? ( virtual/x11 ) \ 35# @DESCRIPTION:
36# Array containing fontconfig conf files to install.
37FONT_CONF=( "" )
38
39# @ECLASS-VARIABLE: DOCS
40# @DESCRIPTION:
41# Space delimited list of docs to install.
42DOCS=${DOCS:-}
43
44IUSE="X"
45
46DEPEND="X? (
47 x11-apps/mkfontdir
48 media-fonts/encodings
49 )
28 media-libs/fontconfig" 50 >=media-libs/fontconfig-2.4.0"
29 51
30# 52# @FUNCTION: font_xfont_config
31# Public functions 53# @DESCRIPTION:
32# 54# Generate Xorg font files (mkfontscale/mkfontdir).
33
34font_xfont_config() { 55font_xfont_config() {
35 56 if has X ${IUSE//+} && use X ; then
36 # create Xfont files
37 if [ -n "`use X`" ] ;
38 then
39 einfo "Creating fonts.scale & fonts.dir..." 57 ebegin "Creating fonts.scale & fonts.dir"
40 mkfontscale ${D}/usr/share/fonts/${PN} 58 rm -f "${ED}${FONTDIR}"/fonts.{dir,scale}
59 mkfontscale "${ED}${FONTDIR}"
41 mkfontdir \ 60 mkfontdir \
42 -e /usr/share/fonts/encodings \ 61 -e ${EPREFIX}/usr/share/fonts/encodings \
43 -e /usr/share/fonts/encodings/large \ 62 -e ${EPREFIX}/usr/share/fonts/encodings/large \
44 -e /usr/X11R6/lib/X11/fonts/encodings \ 63 "${ED}${FONTDIR}"
45 ${D}/usr/share/fonts/${PN} 64 eend $?
65 if [[ -e ${FONT_S}/fonts.alias ]] ; then
46 doins ${FONT_S}/fonts.alias 66 doins "${FONT_S}"/fonts.alias
47 fi 67 fi
48 68 fi
49} 69}
50 70
71# @FUNCTION: font_fontconfig
72# @DESCRIPTION:
73# Install fontconfig conf files given in FONT_CONF.
51font_xft_config() { 74font_fontconfig() {
52 75 local conffile
53 # create fontconfig cache 76 if [[ -n ${FONT_CONF[@]} ]]; then
54 einfo "Creating fontconfig cache..." 77 insinto /etc/fonts/conf.avail/
55 HOME="/root" /usr/bin/fc-cache -f ${D}/usr/share/fonts/${PN} 78 for conffile in "${FONT_CONF[@]}"; do
56 79 [[ -e ${conffile} ]] && doins ${conffile}
80 done
81 fi
57} 82}
58 83
59# 84# @FUNCTION: font_cleanup_dirs
60# Public inheritable functions 85# @DESCRIPTION:
61# 86# Remove font directories containing only generated files.
87font_cleanup_dirs() {
88 local genfiles="encodings.dir fonts.alias fonts.cache-1 fonts.dir fonts.scale"
89 local d f g generated candidate otherfile
62 90
91 ebegin "Purging empty font directories"
92 find -L "${EROOT}"usr/share/fonts/ -type d -print0 | while read -d $'\0' d; do
93 candidate=false
94 otherfile=false
95 for f in "${d}"/*; do
96 generated=false
97 [[ -e ${f} || -L ${f} ]] || continue
98 for g in ${genfiles}; do
99 if [[ ${f##*/} == ${g} ]]; then
100 generated=true
101 break
102 fi
103 done
104 ${generated} && candidate=true || otherfile=true
105 [[ ${candidate} == ${otherfile} ]] && break # both are true, keep the dir
106 done
107 if [[ ${candidate} == true && ${otherfile} == false ]]; then
108 ebegin "Removing ${d}"
109 rm -rf "${d}"
110 eend $?
111 fi
112 done
113 eend 0
114}
115
116# @FUNCTION: font_src_install
117# @DESCRIPTION:
118# The font src_install function.
63font_src_install() { 119font_src_install() {
64
65 local suffix doc 120 local suffix commondoc
66 121
67 cd ${FONT_S} 122 pushd "${FONT_S}" > /dev/null
68 123
69 insinto /usr/share/fonts/${PN} 124 insinto "${FONTDIR}"
70 125
71 for suffix in ${FONT_SUFFIX}; do 126 for suffix in ${FONT_SUFFIX}; do
72 doins *.${suffix} 127 doins *.${suffix}
73 done 128 done
74 129
75 rm -f fonts.{dir,scale} encodings.dir 130 rm -f fonts.{dir,scale} encodings.dir
76 131
77 font_xfont_config 132 font_xfont_config
78 font_xft_config 133 font_fontconfig
79 134
80 cd ${S} 135 popd > /dev/null
136
137 [[ -n ${DOCS} ]] && { dodoc ${DOCS} || die "docs installation failed" ; }
138
81 # try to install some common docs 139 # install common docs
82 DOCS="${DOCS} COPYRIGHT README NEWS" 140 for commondoc in COPYRIGHT README{,.txt} NEWS AUTHORS BUGS ChangeLog FONTLOG.txt; do
83 for doc in ${DOCS}; do 141 [[ -s ${commondoc} ]] && dodoc ${commondoc}
84 dodoc ${doc}
85 done 142 done
86
87} 143}
88 144
89EXPORT_FUNCTIONS src_install 145# @FUNCTION: font_pkg_setup
146# @DESCRIPTION:
147# The font pkg_setup function.
148# Collision protection and Prefix compat for eapi < 3.
149font_pkg_setup() {
150 # Prefix compat
151 case ${EAPI:-0} in
152 0|1|2)
153 if ! use prefix; then
154 EPREFIX=
155 ED=${D}
156 EROOT=${ROOT}
157 [[ ${EROOT} = */ ]] || EROOT+="/"
158 fi
159 ;;
160 esac
161
162 # make sure we get no collisions
163 # setup is not the nicest place, but preinst doesn't cut it
164 [[ -e "${EROOT}/${FONTDIR}/fonts.cache-1" ]] && rm -f "${EROOT}/${FONTDIR}/fonts.cache-1"
165}
166
167# @FUNCTION: font_pkg_postinst
168# @DESCRIPTION:
169# The font pkg_postinst function.
170font_pkg_postinst() {
171 # unreadable font files = fontconfig segfaults
172 find "${EROOT}"usr/share/fonts/ -type f '!' -perm 0644 -print0 \
173 | xargs -0 chmod -v 0644 2>/dev/null
174
175 if [[ -n ${FONT_CONF[@]} ]]; then
176 local conffile
177 echo
178 elog "The following fontconfig configuration files have been installed:"
179 elog
180 for conffile in "${FONT_CONF[@]}"; do
181 if [[ -e ${EROOT}etc/fonts/conf.avail/$(basename ${conffile}) ]]; then
182 elog " $(basename ${conffile})"
183 fi
184 done
185 elog
186 elog "Use \`eselect fontconfig\` to enable/disable them."
187 echo
188 fi
189
190 if [[ ${ROOT} == / ]]; then
191 ebegin "Updating global fontcache"
192 fc-cache -fs
193 eend $?
194 fi
195}
196
197# @FUNCTION: font_pkg_postrm
198# @DESCRIPTION:
199# The font pkg_postrm function.
200font_pkg_postrm() {
201 font_cleanup_dirs
202
203 # unreadable font files = fontconfig segfaults
204 find "${EROOT}"usr/share/fonts/ -type f '!' -perm 0644 -print0 \
205 | xargs -0 chmod -v 0644 2>/dev/null
206
207 if [[ ${ROOT} == / ]]; then
208 ebegin "Updating global fontcache"
209 fc-cache -fs
210 eend $?
211 fi
212}

Legend:
Removed from v.1.2  
changed lines
  Added in v.1.50

  ViewVC Help
Powered by ViewVC 1.1.20